std::enable_shared_from_this< _Tp >(3cxx)

NAME
std::enable_shared_from_this< _Tp > - Base class allowing use of member function shared_from_this.

SYNOPSIS

#include <shared_ptr.h>

  Public Member Functions

shared_ptr< _Tp > shared_from_this ()
shared_ptr< const _Tp > shared_from_this () const
weak_ptr< const _Tp > weak_from_this () const noexcept
weak_ptr< _Tp > weak_from_this () noexcept

  Protected Member Functions

enable_shared_from_this (const enable_shared_from_this &) noexcept
enable_shared_from_this & operator= (const enable_shared_from_this &) noexcept

  Friends

const enable_shared_from_this * __enable_shared_from_this_base (const __shared_count<> &, const enable_shared_from_this *__p)
template<typename , _Lock_policy > class __shared_ptr

Detailed Description

  template<typename _Tp>
class std::enable_shared_from_this< _Tp >"Base class allowing use of member function shared_from_this.

Definition at line 635 of file bits/shared_ptr.h.

Constructor & Destructor Documentation

  template<typename _Tp > constexpr std::enable_shared_from_this< _Tp >::enable_shared_from_this () [inline], [constexpr], [protected], [noexcept]

Definition at line 638 of file bits/shared_ptr.h.

  template<typename _Tp > std::enable_shared_from_this< _Tp >::enable_shared_from_this (const enable_shared_from_this< _Tp > &) [inline], [protected], [noexcept]

Definition at line 640 of file bits/shared_ptr.h.

  template<typename _Tp > std::enable_shared_from_this< _Tp >::~enable_shared_from_this () [inline], [protected]

Definition at line 646 of file bits/shared_ptr.h.

Member Function Documentation

  template<typename _Tp > enable_shared_from_this & std::enable_shared_from_this< _Tp >::operator= (const enable_shared_from_this< _Tp > &) [inline], [protected], [noexcept]

Definition at line 643 of file bits/shared_ptr.h.

  template<typename _Tp > shared_ptr< _Tp > std::enable_shared_from_this< _Tp >::shared_from_this () [inline]

Definition at line 650 of file bits/shared_ptr.h.

  template<typename _Tp > shared_ptr< const _Tp > std::enable_shared_from_this< _Tp >::shared_from_this () const [inline]

Definition at line 654 of file bits/shared_ptr.h.

  template<typename _Tp > weak_ptr< const _Tp > std::enable_shared_from_this< _Tp >::weak_from_this () const [inline], [noexcept]

Definition at line 664 of file bits/shared_ptr.h.

  template<typename _Tp > weak_ptr< _Tp > std::enable_shared_from_this< _Tp >::weak_from_this () [inline], [noexcept]

Definition at line 660 of file bits/shared_ptr.h.

Friends And Related Symbol Documentation

  template<typename _Tp > const enable_shared_from_this * __enable_shared_from_this_base (const __shared_count<> &, const enable_shared_from_this< _Tp > * __p) [friend]

Definition at line 676 of file bits/shared_ptr.h.

  template<typename _Tp > template<typename , _Lock_policy > friend class __shared_ptr [friend]

Definition at line 681 of file bits/shared_ptr.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.